/*
 * Copyright 2010 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.callbackparams.internal;

import java.lang.reflect.Field;
import java.lang.reflect.Method;

/**
 * @author Henrik Kaipe
 */
public interface CallbackRebyteInfo {

    boolean isCallbackProxiedMethod(Method m);

    boolean isTestMethod(Method m);

    boolean isCallbackInjectField(Field f);

    boolean isAdaptiveRuleField(Field f);

    void putNoargProxyMethod(
            String proxyMethodName, Method callbackProxiedMethod);

    boolean isExplicitTopClass(Class clazz);

    Class adaptiveRuleSuperClass();
}
