/*
 * Copyright 2010 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.callbackparams.junit4.support;

import java.util.List;
import java.util.ListIterator;
import org.junit.Test;
import org.junit.runners.BlockJUnit4ClassRunner;
import org.junit.runners.model.FrameworkMethod;
import org.junit.runners.model.InitializationError;

/**
 * @author Henrik Kaipe
 */
public class JUnit4CallbackParamsFilteredExtension
extends BlockJUnit4ClassRunner {

    public JUnit4CallbackParamsFilteredExtension(Class<?> klass)
    throws InitializationError {
        super(klass);
    }

    @Override
    protected void collectInitializationErrors(List<Throwable> errors) {
        final ListIterator<FrameworkMethod> li =
                getTestClass().getAnnotatedMethods(Test.class).listIterator();
        while (li.hasNext()) {
            final FrameworkMethod fm = li.next();
            if (ExperimentalUtils.isCallbackParamsMethod(fm.getMethod())) {
                li.remove();
            }
        }
        
        super.collectInitializationErrors(errors);
    }
}
